#include <myx/base/config.hpp>
#include <myx/filesystem/current_executable.hpp>

#include <paths.h>

#include <QCoreApplication>
#include <QString>

namespace myx {

namespace filesystem {

#if !defined ( __linux__ )
error "Class CurrentExecutable is supported only in Linux"
#endif

CurrentExecutable::CurrentExecutable() :
	m_procFilePath( QStringLiteral( "/proc/self/exe" ) )
{
	m_canonicalFilePath = m_procFilePath.canonicalFilePath();
}


const QFileInfo& CurrentExecutable::canonicalFilePath() const
{
	return( m_canonicalFilePath );
}

} // namespace filesystem

} // namespace myx
