#ifndef MYX_MATH_ALMOST_EQUAL_RELATIVE_AND_ABS_HPP_
#define MYX_MATH_ALMOST_EQUAL_RELATIVE_AND_ABS_HPP_

#include <cfloat>

namespace myx {

namespace math {

/**
 * @brief Проверка на равенство двух аргументов типа float.
 *        Параметр maxAbsDiff определяет максимальную абсолютную допустимую разницу.
 *        Параметр maxRelDiff определяет максимальную относительную допустимую разницу,
 *        при которой аргументы считаются равными.
 */
bool almost_equal_relative_and_abs( const float a, const float b,
                                    const float maxAbsDiff, const float maxRelDiff = FLT_EPSILON );
/**
 * @brief Проверка на равенство двух аргументов типа double.
 *        Параметр maxAbsDiff определяет максимальную абсолютную допустимую разницу.
 *        Параметр maxRelDiff определяет максимальную относительную допустимую разницу,
 *        при которой аргументы считаются равными.
 */
bool almost_equal_relative_and_abs( const double a, const double b,
                                    const double maxAbsDiff, const double maxRelDiff = DBL_EPSILON );

} // namespace math

} // namespace myx

#endif // MYX_MATH_ALMOST_EQUAL_RELATIVE_AND_ABS_HPP_
